ON_BezierCurve Class Reference

`#include <pcl/surface/3rdparty/opennurbs/opennurbs_bezier.h>`

## Public Member Functions

| ON_BezierCurve ()
| ON_BezierCurve (int dim, ON_BOOL32 bIsRational, int order)
| ~ON_BezierCurve ()
| ON_BezierCurve (const ON_BezierCurve &)
| ON_BezierCurve (const ON_PolynomialCurve &)
| ON_BezierCurve (const ON_2dPointArray &)
| ON_BezierCurve (const ON_3dPointArray &)
| ON_BezierCurve (const ON_4dPointArray &)
ON_BezierCurve & | operator= (const ON_BezierCurve &)
ON_BezierCurve & | operator= (const ON_PolynomialCurve &)
ON_BezierCurve & | operator= (const ON_2dPointArray &)
ON_BezierCurve & | operator= (const ON_3dPointArray &)
ON_BezierCurve & | operator= (const ON_4dPointArray &)
bool | IsValid () const
void | Dump (ON_TextLog &) const
int | Dimension () const
bool | Create (int dim, ON_BOOL32 bIsRational, int order)
void | Destroy ()
void | EmergencyDestroy ()
bool | Loft (const ON_3dPointArray &points)
bool | Loft (int pt_dim, int pt_count, int pt_stride, const double *pt, int t_stride, const double *t)
bool | GetBBox (double *box_min, double *box_max, int bGrowBox=false) const
bool | GetBoundingBox (ON_BoundingBox &bbox, int bGrowBox=false) const
ON_BoundingBox | BoundingBox () const
bool | GetTightBoundingBox (ON_BoundingBox &tight_bbox, int bGrowBox=false, const ON_Xform *xform=0) const
bool | Transform (const ON_Xform &xform)
bool | Rotate (double sin_angle, double cos_angle, const ON_3dVector &rotation_axis, const ON_3dPoint &rotation_center)
bool | Rotate (double rotation_angle, const ON_3dVector &rotation_axis, const ON_3dPoint &rotation_center)
bool | Translate (const ON_3dVector &translation_vector)
bool | Scale (double scale_factor)
ON_Interval | Domain () const
bool | Reverse ()
ON_3dPoint | PointAt (double t) const
ON_3dVector | DerivativeAt (double t) const
ON_3dVector | TangentAt (double t) const
ON_3dVector | CurvatureAt (double t) const
bool | EvPoint (double t, ON_3dPoint &point) const
bool | Ev1Der (double t, ON_3dPoint &point, ON_3dVector &first_derivative) const
bool | Ev2Der (double t, ON_3dPoint &point, ON_3dVector &first_derivative, ON_3dVector &second_derivative) const
bool | EvTangent (double t, ON_3dPoint &point, ON_3dVector &tangent) const
bool | EvCurvature (double t, ON_3dPoint &point, ON_3dVector &tangent, ON_3dVector &kappa) const
bool | Evaluate (double t, int der_count, int v_stride, double *v) const
bool | GetNurbForm (ON_NurbsCurve &nurbs_curve) const
bool | IsRational () const
int | CVSize () const
int | CVCount () const
int | Order () const
int | Degree () const
double * | CV (int cv_index) const
ON::point_style | CVStyle () const
double | Weight (int cv_index) const
bool | SetWeight (int cv_index, double weight)
bool | SetCV (int cv_index, ON::point_style pointstyle, const double *cv)
bool | SetCV (int cv_index, const ON_3dPoint &point)
bool | SetCV (int cv_index, const ON_4dPoint &point)
bool | GetCV (int cv_index, ON::point_style pointstyle, double *cv) const
bool | GetCV (int cv_index, ON_3dPoint &point) const
bool | GetCV (int cv_index, ON_4dPoint &point) const
bool | ZeroCVs ()
bool | MakeRational ()
bool | MakeNonRational ()
bool | IncreaseDegree (int desired_degree)
bool | ChangeDimension (int desired_dimension)
bool | ReserveCVCapacity (int desired_cv_capacity)
bool | Trim (const ON_Interval &interval)
bool | Split (double t, ON_BezierCurve &left_side, ON_BezierCurve &right_side) const
double | ControlPolygonLength () const
bool | Reparameterize (double c)
ON_DEPRECATED bool | Reparametrize (double)
bool | ScaleConrolPoints (int i, double w)
bool | ChangeWeights (int i0, double w0, int i1, double w1)

## Public Attributes

int | m_dim
int | m_is_rat
int | m_order
int | m_cv_stride
double * | m_cv
int | m_cv_capacity

## Detailed Description

Definition at line 148 of file opennurbs_bezier.h.

## Constructor & Destructor Documentation

ON_BezierCurve::ON_BezierCurve | ( |  | ) |

ON_BezierCurve::ON_BezierCurve | ( | int | dim,
|  | ON_BOOL32 | bIsRational,
|  | int | order
| ) |  |

ON_BezierCurve::~ON_BezierCurve | ( |  | ) |

ON_BezierCurve::ON_BezierCurve | ( | const ON_BezierCurve & |  | ) |

ON_BezierCurve::ON_BezierCurve | ( | const ON_PolynomialCurve & |  | ) |

ON_BezierCurve::ON_BezierCurve | ( | const ON_2dPointArray & |  | ) |

ON_BezierCurve::ON_BezierCurve | ( | const ON_3dPointArray & |  | ) |

ON_BezierCurve::ON_BezierCurve | ( | const ON_4dPointArray & |  | ) |

## Member Function Documentation

ON_BoundingBox ON_BezierCurve::BoundingBox | ( |  | ) | const

bool ON_BezierCurve::ChangeDimension | ( | int | desired_dimension | ) |

bool ON_BezierCurve::ChangeWeights | ( | int | i0,
|  | double | w0,
|  | int | i1,
|  | double | w1
| ) |  |

double ON_BezierCurve::ControlPolygonLength | ( |  | ) | const

bool ON_BezierCurve::Create | ( | int | dim,
|  | ON_BOOL32 | bIsRational,
|  | int | order
| ) |  |

ON_3dVector ON_BezierCurve::CurvatureAt | ( | double | t | ) | const

double* ON_BezierCurve::CV | ( | int | cv_index | ) | const

int ON_BezierCurve::CVCount | ( |  | ) | const

int ON_BezierCurve::CVSize | ( |  | ) | const

ON::point_style ON_BezierCurve::CVStyle | ( |  | ) | const

int ON_BezierCurve::Degree | ( |  | ) | const

ON_3dVector ON_BezierCurve::DerivativeAt | ( | double | t | ) | const

void ON_BezierCurve::Destroy | ( |  | ) |

int ON_BezierCurve::Dimension | ( |  | ) | const

ON_Interval ON_BezierCurve::Domain | ( |  | ) | const

void ON_BezierCurve::Dump | ( | ON_TextLog & |  | ) | const

void ON_BezierCurve::EmergencyDestroy | ( |  | ) |

bool ON_BezierCurve::Ev1Der | ( | double | t,
|  | ON_3dPoint & | point,
|  | ON_3dVector & | first_derivative
| ) |  | const

bool ON_BezierCurve::Ev2Der | ( | double | t,
|  | ON_3dPoint & | point,
|  | ON_3dVector & | first_derivative,
|  | ON_3dVector & | second_derivative
| ) |  | const

bool ON_BezierCurve::Evaluate | ( | double | t,
|  | int | der_count,
|  | int | v_stride,
|  | double * | v
| ) |  | const

bool ON_BezierCurve::EvCurvature | ( | double | t,
|  | ON_3dPoint & | point,
|  | ON_3dVector & | tangent,
|  | ON_3dVector & | kappa
| ) |  | const

bool ON_BezierCurve::EvPoint | ( | double | t,
|  | ON_3dPoint & | point
| ) |  | const

bool ON_BezierCurve::EvTangent | ( | double | t,
|  | ON_3dPoint & | point,
|  | ON_3dVector & | tangent
| ) |  | const

bool ON_BezierCurve::GetBBox | ( | double * | box_min,
|  | double * | box_max,
|  | int | bGrowBox = `false`
| ) |  | const

bool ON_BezierCurve::GetBoundingBox | ( | ON_BoundingBox & | bbox,
|  | int | bGrowBox = `false`
| ) |  | const

bool ON_BezierCurve::GetCV | ( | int | cv_index,
|  | ON::point_style | pointstyle,
|  | double * | cv
| ) |  | const

bool ON_BezierCurve::GetCV | ( | int | cv_index,
|  | ON_3dPoint & | point
| ) |  | const

bool ON_BezierCurve::GetCV | ( | int | cv_index,
|  | ON_4dPoint & | point
| ) |  | const

bool ON_BezierCurve::GetNurbForm | ( | ON_NurbsCurve & | nurbs_curve | ) | const

bool ON_BezierCurve::GetTightBoundingBox | ( | ON_BoundingBox & | tight_bbox,
|  | int | bGrowBox = `false`,
|  | const ON_Xform * | xform = `0`
| ) |  | const

bool ON_BezierCurve::IncreaseDegree | ( | int | desired_degree | ) |

bool ON_BezierCurve::IsRational | ( |  | ) | const

bool ON_BezierCurve::IsValid | ( |  | ) | const

bool ON_BezierCurve::Loft | ( | const ON_3dPointArray & | points | ) |

bool ON_BezierCurve::Loft | ( | int | pt_dim,
|  | int | pt_count,
|  | int | pt_stride,
|  | const double * | pt,
|  | int | t_stride,
|  | const double * | t
| ) |  |

bool ON_BezierCurve::MakeNonRational | ( |  | ) |

bool ON_BezierCurve::MakeRational | ( |  | ) |

ON_BezierCurve& ON_BezierCurve::operator= | ( | const ON_BezierCurve & |  | ) |

ON_BezierCurve& ON_BezierCurve::operator= | ( | const ON_PolynomialCurve & |  | ) |

ON_BezierCurve& ON_BezierCurve::operator= | ( | const ON_2dPointArray & |  | ) |

ON_BezierCurve& ON_BezierCurve::operator= | ( | const ON_3dPointArray & |  | ) |

ON_BezierCurve& ON_BezierCurve::operator= | ( | const ON_4dPointArray & |  | ) |

int ON_BezierCurve::Order | ( |  | ) | const

ON_3dPoint ON_BezierCurve::PointAt | ( | double | t | ) | const

bool ON_BezierCurve::Reparameterize | ( | double | c | ) |

ON_DEPRECATED bool ON_BezierCurve::Reparametrize | ( | double |  | ) |

bool ON_BezierCurve::ReserveCVCapacity | ( | int | desired_cv_capacity | ) |

bool ON_BezierCurve::Reverse | ( |  | ) |

bool ON_BezierCurve::Rotate | ( | double | sin_angle,
|  | double | cos_angle,
|  | const ON_3dVector & | rotation_axis,
|  | const ON_3dPoint & | rotation_center
| ) |  |

bool ON_BezierCurve::Rotate | ( | double | rotation_angle,
|  | const ON_3dVector & | rotation_axis,
|  | const ON_3dPoint & | rotation_center
| ) |  |

bool ON_BezierCurve::Scale | ( | double | scale_factor | ) |

bool ON_BezierCurve::ScaleConrolPoints | ( | int | i,
|  | double | w
| ) |  |

bool ON_BezierCurve::SetCV | ( | int | cv_index,
|  | ON::point_style | pointstyle,
|  | const double * | cv
| ) |  |

bool ON_BezierCurve::SetCV | ( | int | cv_index,
|  | const ON_3dPoint & | point
| ) |  |

bool ON_BezierCurve::SetCV | ( | int | cv_index,
|  | const ON_4dPoint & | point
| ) |  |

bool ON_BezierCurve::SetWeight | ( | int | cv_index,
|  | double | weight
| ) |  |

bool ON_BezierCurve::Split | ( | double | t,
|  | ON_BezierCurve & | left_side,
|  | ON_BezierCurve & | right_side
| ) |  | const

ON_3dVector ON_BezierCurve::TangentAt | ( | double | t | ) | const

bool ON_BezierCurve::Transform | ( | const ON_Xform & | xform | ) |

bool ON_BezierCurve::Translate | ( | const ON_3dVector & | translation_vector | ) |

bool ON_BezierCurve::Trim | ( | const ON_Interval & | interval | ) |

double ON_BezierCurve::Weight | ( | int | cv_index | ) | const

bool ON_BezierCurve::ZeroCVs | ( |  | ) |

## Member Data Documentation

double* ON_BezierCurve::m_cv

Definition at line 976 of file opennurbs_bezier.h.

int ON_BezierCurve::m_cv_capacity

Definition at line 982 of file opennurbs_bezier.h.

int ON_BezierCurve::m_cv_stride

Definition at line 973 of file opennurbs_bezier.h.

int ON_BezierCurve::m_dim

Definition at line 964 of file opennurbs_bezier.h.

int ON_BezierCurve::m_is_rat

Definition at line 967 of file opennurbs_bezier.h.

int ON_BezierCurve::m_order

Definition at line 970 of file opennurbs_bezier.h.

The documentation for this class was generated from the following file:

- /build/pcl-6_P28C/pcl-1.7.2/surface/include/pcl/surface/3rdparty/opennurbs/opennurbs_bezier.h